



def test():

    from Ft.Ods import Database
    from Ft.Ods.MetaData import Enumeration
    from Ft.Ods.MetaData import Constant
    from Ft.Ods.MetaData import Literal
    from Ft.Ods.Collections import LiteralListOfRepositoryObjects

    from Ft.Ods.StorageManager.Adapters import Constants

 
    db = Database.Database()
    db.open('test')
    tx = db.new()
    tx.begin()

    c1 = Constant.Constant()
    l = Literal.Literal()
    l.literal_value = 1
    c1.name = "MONDAY"
    c1.form_the_Value(l)

    c2 = Constant.Constant()
    l = Literal.Literal()
    l.literal_value = 2
    c2.name = 'TUESDAY'
    c2.form_the_Value(l)


    e = Enumeration.Enumeration()
    e.name = 'WeekDays'
    e.add_elements(c1)
    e.add_elements(c2)

    print e
    print e.tupleNames
    print e.tupleTypes
    print e._4ods_getFullTuple()
    print e._4ods_getOdl()


    tx.commit()

    id = e._4ods_getId()

    tx = db.new()
    tx.begin()
    print "Read from DB"
    e2 = db._4ods_getPersistentObjectById(Constants.ObjectTypes.REPO,id)

    print e2
    print e2._4ods_getOdl()
    print e2.elements._4ods_getContents()

    tx.abort()

    tx = db.new()
    tx.begin()
    print "Create from defining scope"

    repo = db.schema()

    from Ft.Ods.Collections import LiteralListOfValues
    names = LiteralListOfValues.LiteralListOfValues(type(''))
    names.insert_element('Mon')
    names.insert_element('Tue')
    e = repo.add_enumeration("WeekDays",names)

    print e
    print e._4ods_getOdl()
    tx.commit()

    db.close()

if __name__ == '__main__':
    test()
