



def test():

    from Ft.Ods import Database
    from Ft.Ods.MetaData import Interface
    from Ft.Ods.Collections import LiteralListOfRepositoryObjects
 
    db = Database.Database()
    db.open('test')
    tx = db.new()
    tx.begin()
    top = db.schema().resolve('ODLTypes')

    i1 = top.add_interface('TopLevel',None)
    
    print i1
    print i1.tupleNames
    print i1.tupleTypes
    print i1._4ods_getFullTuple()
    print i1._4ods_getModifiedTuple()

    l = LiteralListOfRepositoryObjects.LiteralListOfRepositoryObjects(Interface.Interface)
    l.insert_element(i1)

    
    i2 = top.add_interface('Inherits',l)
    
    print "***State of Top****"
    print i1
    print i1.tupleNames
    print i1.tupleTypes
    print i1._4ods_getFullTuple()
    print i1._4ods_getModifiedTuple()

    print "***State of Derives****"
    print i2
    print i2.tupleNames
    print i2.tupleTypes
    print i2._4ods_getFullTuple()
    print i2._4ods_getModifiedTuple()



    print top._4ods_getOdl()

    i1.add_attribute('test',i2)

    tx.commit()


    id = i1._4ods_getRepoId()
    id2 = i2._4ods_getRepoId()

    tx = db.new()
    tx.begin()

    print "Start second transactions"
    i1 = db._4ods_getRepositoryObjectById(id)
    i2 = db._4ods_getRepositoryObjectById(id2)

    print i1
    print i1.name

    a = i1.add_attribute('a1',i1)

    r = i1.add_relationship('r1',i2,i2,'inverse_r1',i1)
    print r
    print r.type


    print i1._4ods_getOdl()




    tx.commit()

    return

    tx = db.new()
    tx.begin()

    print "Start third transactions"
    m = db._4ods_getRepositoryObjectById(id)

    m.name = 'NewName'
    print m.resolve('Inside')

    tx.commit()

    tx = db.new()
    tx.begin()

    print "Start Fourth transactions"
    m = db._4ods_getRepositoryObjectById(id)
    m2 = m.defines._4ods_getContents()[0]
    m.remove_module(m2)
    m2.delete()
    tx.commit()


    db.close()

if __name__ == '__main__':
    test()
