



def test():

    from Ft.Ods import Database
    from Ft.Ods.MetaData import Member
    from Ft.Ods.MetaData import PrimitiveType
    from Ft.Ods.Collections import LiteralListOfRepositoryObjects
    from Ft.Ods.StorageManager.Adapters import Constants

 
    db = Database.Database()
    db.open('test')
    tx = db.new()
    tx.begin()
    repo = db.schema()
    

    m = Member.Member()
    m.form_type(repo.resolve("pk_short"))
    m.name = "Age"


    print m.tupleNames
    print m.tupleTypes
    print m._4ods_getFullTuple()

    tx.commit()

    id = m._4ods_getId()

    tx = db.new()
    tx.begin()
    print "Read from DB"
    m2 = db._4ods_getPersistentObjectById(Constants.ObjectTypes.REPO,id)

    print m2
    print m2.name
    print m2.type

    tx.abort()


    tx = db.new()
    tx.begin()
    print "Create from defining scope"

    repo = db.schema()

    m3 = repo.create_member("member2",repo.resolve("pk_string"))
    print m3
    print m3.name
    tx.abort()
    db.close()

if __name__ == '__main__':
    test()
