from xml.xpath import ParsedExpr
from xml.xpath import Boolean
from xml.xpath.ParsedExpr import NodeSet

class DummyBooleanExpr(ParsedExpr.ParsedExpr):

    def __init__(self,val):
        ParsedExpr.ParsedExpr.__init__(self)
        self.val = Boolean.BooleanType(val)

    def evaluate(self,context):
        return self.val

    def __repr__(self):
        return str(self.val)

class DummyNumberExpr(ParsedExpr.ParsedExpr):

    def __init__(self,val):
        ParsedExpr.ParsedExpr.__init__(self)
        self.val = val

    def evaluate(self,context):
        return self.val

    def __repr__(self):
        return str(self.val)

import DomTree

class DummyNodeSetExpr(ParsedExpr.ParsedExpr):
    def __init__(self,val=None):
        ParsedExpr.ParsedExpr.__init__(self)
        self.val = val or NodeSet([DomTree.ROOT, DomTree.GCHILD12])

    def evaluate(self,context):
        return self.val

    def select(self,context):
        return self.val

    def __repr__(self):
        return repr(self.val)

class DummyStringExpr(ParsedExpr.ParsedExpr):
    def __init__(self,val=None):
        ParsedExpr.ParsedExpr.__init__(self)
        self.val = val or 'DummyString'

    def evaluate(self,context):
        return self.val

    def __repr__(self):
        return repr(self.val)


