



def test():

    from Ft.Ods import Database
    from Ft.Ods.MetaData import Module
 
    db = Database.Database()
    db.open('test')
    tx = db.new()
    tx.begin()
    top = db.schema().resolve('ODLTypes')


    m = top.add_module('Outside')

    print m.tupleNames
    print m.tupleTypes
    print m._4ods_getFullTuple()
    print m._4ods_getModifiedTuple()

    m2 = m.add_module('Inside')

    print m._4ods_getOdl()

    tx.commit()

    id = m._4ods_getRepoId()


    tx = db.new()
    tx.begin()

    print "Start second transactions"
    m = db._4ods_getRepositoryObjectById(id)

    print m
    print m.name
    print m.defines
    print m.defines._4ods_getContents()
    print m.defines._4ods_getContents()[0].name

    tx.commit()

    tx = db.new()
    tx.begin()

    print "Start third transactions"
    m = db._4ods_getRepositoryObjectById(id)

    m.name = 'NewName'
    print m.resolve('Inside')

    tx.commit()

    tx = db.new()
    tx.begin()

    print "Start Fourth transactions"
    m = db._4ods_getRepositoryObjectById(id)
    m2 = m.defines._4ods_getContents()[0]
    m.remove_module(m2)
    m2.delete()
    tx.commit()


    db.close()

if __name__ == '__main__':
    test()
