



def test():

    from Ft.Ods import Database
    from Ft.Ods.MetaData import RepositoryObject
    from Ft.Ods.MetaData import Property

    d = Database.Database()
    d.open('test')
    tx = d.new()
    tx.begin()

    p = Property.Property(RepositoryObject.MetaKind.mk_attribute)
    p.name = "A Name"
    p.comment = "Comment"


    print p
    print p.tupleNames
    print p.tupleTypes
    print p._4ods_getFullTuple()
    print p._4ods_getModifiedTuple()

    #Test forming the type relationship
    from Ft.Ods.MetaData import Type
    t = Type.Type(RepositoryObject.MetaKind.mk_primitive_type)

    print t
    t._4ods_setRepoId(698)

    p.form_type(t)

    print p.type
    print p.tupleNames
    print p.tupleTypes
    print p._4ods_getFullTuple()
    print p._4ods_getModifiedTuple()
    print t.properties._4ods_getContents()


    p.drop_type(t)
    print p.type
    print p.tupleNames
    print p.tupleTypes
    print p._4ods_getFullTuple()
    print p._4ods_getModifiedTuple()
    print t.properties._4ods_getContents()


    d.close()

if __name__ == '__main__':
    test()
