



def test():

    from Ft.Ods import Database
    from Ft.Ods.MetaData import Structure
    from Ft.Ods.MetaData import Member
    from Ft.Ods.MetaData import PrimitiveType
    from Ft.Ods.Collections import LiteralListOfRepositoryObjects
    from Ft.Ods.StorageManager.Adapters import Constants

 
    db = Database.Database()
    db.open('test')
    tx = db.new()
    tx.begin()
    repo = db.schema()
    

    s = Structure.Structure()
    s.name = "Kirk"

    m = Member.Member()
    m.form_type(repo.resolve("pk_short"))
    m.name = "Age"


    s.form_fields(m)

    print s.tupleNames
    print s.tupleTypes
    print s._4ods_getFullTuple()


    tx.commit()

    id = s._4ods_getId()

    tx = db.new()
    tx.begin()
    print "Read from DB"
    s2 = db._4ods_getPersistentObjectById(Constants.ObjectTypes.REPO,id)

    print s2
    print s2.name
    print s2.fields._4ods_getContents()

    tx.abort()

    tx = db.new()
    tx.begin()
    print "Create from defining scope"

    repo = db.schema()

    m3 = repo.create_member("member1",repo.resolve("pk_string"))

    s2 = repo.add_structure("NewS",[m3])

    print s2
    print s2.name
    print s2.fields._4ods_getContents()

    tx.abort()
    db.close()

if __name__ == '__main__':
    test()
