#!/usr/bin/env python
########################################################################
#
# File Name:   test.pt
#
# Docs:        http://docs.4suite.com/XPath/test_suite/test.py.html
#

#[preferably one-line description of file]
#WWW: http://4suite.com/XPATH        e-mail: support@4suite.com
#
#Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
#See  http://4suite.com/COPYRIGHT  for license and copyright information

disabled = """
             'TestParsedAxisSpecifier',
             'TestParsedLocationPath',
             'TestUtil'
"""

TestFiles = ['TestBooleanExpr',
             'TestCoreFunctions',
             'TestError',
             'TestNodeSetExpr',
             'TestNumber',
             'TestParsedAbbreviatedAbsoluteLocationPath',
             'TestParsedAbbreviatedRelativeLocationPath',
             'TestParsedAbsoluteLocationPath',
             'TestParsedNodeTest',
             'TestParsedPredicateList',
             'TestParsedRelativeLocationPath',
             'TestParsedStep',
             'TestParsedTokens',
             'TestPathParser',
             ]


def test():

    from xml.xpath import XPathParserBase
    import sys

    for file in TestFiles:
        m = __import__(file)
        try:
            print '#'*15,file,'#'*15
            m.test()
        except XPathParserBase.ParseTreeException, e:
            XPathParserBase.PrintParseTreeException(e)
            sys.exit()
        except XPathParserBase.SyntaxException, e:
            XPathParserBase.PrintSyntaxException(e)
            sys.exit()

if __name__ == '__main__':
    test()
