

from Ft.Lib import TestSuite

from Ft.Lib import Uri

test_cases = [('','file:docs/xml/4XLink.api','file:docs/xml/4XLink.api','file:docs/xml/'),
              ('file:docs/xml/','file:docs/xml/4XLink.api','file:docs/xml/4XLink.api','file:docs/xml/'),
              ('file:/usr/local/lib/xslt/bar.xslt','http://4Suite.org/foo.xslt','http://4Suite.org/foo.xslt','http://4Suite.org/'),
              ]


def test(tester):

    tester.startGroup("Uri Normalize")

    resolver = Uri.BaseUriResolver()
    for base,relative,expectedUri,expectedBase in test_cases:
        tester.startTest("Uri: base=%s uri=%s" % (base,relative))

        res = resolver.normalize(relative,base)
        tester.testResults(expectedBase,res[1],done=0,msg="Invalid Base Uri")
        tester.testResults(expectedUri,res[0],done=0,msg="Invalid Uri")


        tester.testDone()

    tester.groupDone()
if __name__ == '__main__':
    tester = TestSuite.TestSuite(1, 1)
    test(tester)
